Attribute VB_Name = "mdlCRC32"
Option Explicit


' Polynom-Tabelle
Dim bCRC32Init As Boolean
Dim nCRC32LookUp() As Long

Public Sub CRC32_Init()
  ' Polynom-Tabelle erstellen
  ' Hier wird das offizielle Polynom verwendet, das
  ' auch von WinZip/PKZip verwendet wird
  
  ' Falls die LookUp-Tabelle bereits erstellt...
  If bCRC32Init Then Exit Sub
  
  Const nPolynom = &HEDBF83E0
  
  Dim i As Long
  Dim u As Long
  
  ReDim nCRC32LookUp(255)
  Dim nCRC32 As Long

  For i = 0 To 255
    nCRC32 = i
    For u = 0 To 7
      If (nCRC32 And 1) Then
        nCRC32 = (((nCRC32 And &HFFFFFFFE) \ 2&) And &H7FFFFFFF) _
          Xor nPolynom
      Else
        nCRC32 = ((nCRC32 And &HFFFFFFFE) \ 2&) And &H7FFFFFFF
      End If
    Next u
    nCRC32LookUp(i) = nCRC32
  Next i
  bCRC32Init = True
End Sub

' Der optionale Parameter "nResult" sollte nur von
' CRC32_File verwendet werden!
Public Function CRC32(ByRef Bytes() As Byte, _
  Optional ByVal nResult As Long = &HFFFFFFFF) As Long
  
  Dim i As Long
  Dim Index As Long
  Dim nSize As Long
  
  ' ggf. LookUp-Tabelle erstellen...
  If Not bCRC32Init Then CRC32_Init

  nSize = UBound(Bytes)
  For i = 0 To nSize
    Index = (nResult And &HFF) Xor Bytes(i)
    nResult = (((nResult And &HFFFFFF00) \ &H100) And 16777215) _
      Xor nCRC32LookUp(Index)
  Next i

  CRC32 = Not (nResult)
End Function

