Attribute VB_Name = "mdlScore"
Option Explicit

'Das hier enthlt die API um Zeilenleise zu schreiben  / lesen
'Wird fr die Higscore bentigt

' Wird bentigt, zum Ermitteln des temporren
' Verzeichnisses und zum Erstellen temporrer Dateien
Private Declare Function GetTempFileName Lib "kernel32" _
  Alias "GetTempFileNameA" (ByVal lpszPath As String, _
  ByVal lpPrefixString As String, _
  ByVal wUnique As Long, _
  ByVal lpTempFileName As String) As Long

Private Declare Function GetTempPath Lib "kernel32.dll" _
  Alias "GetTempPathA" (ByVal nBufferLength As Long, _
  ByVal lpBuffer As String) As Long

Private winTempPath As String


' Ermittelt einen temporren Dateinamen
' im temporren Verzeichnis
Private Function txt_TempFilename() As String
  Dim myTempFileName As String
  Dim RetVal As Long
  
  If winTempPath = "" Then
    ' Temporres Verzeichnis ermitteln
    winTempPath = Space$(256)
    RetVal = GetTempPath(Len(winTempPath), winTempPath)
    winTempPath = Left$(winTempPath, RetVal)
  End If
  
  ' Temporren Dateinamen ermitteln
  myTempFileName = Space$(256)
  Call GetTempFileName(winTempPath, "txt", 0&, myTempFileName)
  myTempFileName = Left$(myTempFileName, _
    InStr(myTempFileName, Chr$(0)) - 1)
  
  txt_TempFilename = myTempFileName
End Function

' Lesen des gesamten Inhaltes einer Textdatei
' sFilename:  vollstndiger Dateiname
' =========================================================
Public Function txt_ReadAll(ByVal sFilename As String) _
  As String

  Dim F As Integer
  Dim sInhalt As String
  
  ' Existiert die Datei ?
  If Dir$(sFilename, vbNormal) <> "" Then
    ' Textdatei im Binrmodus ffnen und gesamten
    ' Inhalt in einem Rutsch auslesen
    F = FreeFile
    Open sFilename For Binary As #F
    sInhalt = Space$(LOF(F))
    Get #F, , sInhalt
    Close #F
  End If
  
  txt_ReadAll = sInhalt
End Function

' Beliebigen Text in eine Textdatei speichern, wobei
' der bisherige Inhalt der Textdatei vollstndig
' berschrieben wird
'
' sFilename:  vollstndiger Dateiname
' sLines   :  Inhalt, der gespeichert werden soll
' ===============================================
Public Sub txt_WriteAll(ByVal sFilename As String, _
  ByVal sLines As String)
  
  Dim F As Integer
  
  ' Datei zum Schreiben ffnen
  ' Achtung: bisheriger Inhalt wird gelscht!
  F = FreeFile
  Open sFilename For Output As #F
  Print #F, sLines
  Close #F
End Sub


' Einzelne Zeile an eine Textdatei anhngen
' sFilename:  vollstndiger Name der Datei
' sLine    :  Inhalt, der gespeichert werden soll
' ===============================================
Public Function txt_AppendLine(ByVal sFilename As String, _
  ByVal sLine As String)

  Dim F As Integer
  
  ' Datei zum "Anhngen" von Daten ffnen
  ' und Textzeile ans Ende anfgen
  F = FreeFile
  Open sFilename For Append As #F
  Print #F, sLine
  Close #F
End Function

' Lesen einer bestimmten Zeile einer Textdatei
' sFilename:  vollstndiger Dateiname
' LineToRead: Zeile, deren Inhalt zurckgegeben werden soll
' =========================================================
Public Function txt_ReadLine(ByVal sFilename As String, _
  ByVal LineToRead As Long) As String

  Dim F As Integer
  Dim sLine As String
  Dim lRow As Long

  lRow = 0
  ' Existiert die Datei ?
  If Dir$(sFilename) <> "" Then
  
    ' Datei zum Lesen ffnen
    F = FreeFile
    Open sFilename For Input As #F
    
    ' Solange einlesen, bis entweder Dateiende
    ' oder gewnschte Zeilennummer erreicht
    While Not EOF(F) And lRow < LineToRead
      lRow = lRow + 1
      Line Input #F, sLine
    Wend
    Close #F
  Else
  End If
  
  ' Dateiende wurde frhzeitig erreicht,
  ' oder Datei war nicht vorhanden
  If lRow < LineToRead Then _
    sLine = ""
    
    txt_ReadLine = sLine
End Function

' Einzelne Zeile in eine Textdatei speichern
' sFilename:  vollstndiger Name der Datei
' LinePos  :  Zeilenummer in der Textdatei
' sLine    :  Inhalt, der gespeichert werden soll
' ===============================================
Public Sub txt_WriteLine(ByVal sFilename As String, _
  ByVal LinePos As Long, ByVal sLine As String)
  
  Dim F As Integer
  Dim N As Integer
  Dim I As Long
  Dim lRow As Long
  Dim Zeile As String
  Dim myTempFile As String

  
  If Dir$(sFilename, vbNormal) = "" Then
    ' Wenn Datei nicht existiert, automatisch erstellen
    ' und Inhalt sofort speichern
    F = FreeFile
    Open sFilename For Output As #F
    
    ' Datei mit Leerzeilen fllen, bis gewnschte
    ' Schreibposition erreicht ist
    For I = 1 To LinePos - 1
      Print #F, ""
    Next I
    
    ' Inhalt speichern
    Print #F, sLine
    Close #F
    
  Else
    ' Temporre Datei erstellen
    myTempFile = txt_TempFilename()
    
    ' Original-Datei zum Lesen und temporre
    ' Datei zum Schreiben ffnen
    F = FreeFile: Open sFilename For Input As #F
    N = FreeFile: Open myTempFile For Output As #N
    
    ' Original-Datei einlesen und x. Zeile durch
    ' neuen Inhalt ersetzen
    lRow = 0
    While Not EOF(F)
      lRow = lRow + 1
      Line Input #F, Zeile
      
      If lRow = LinePos Then
        ' x. Zeile durch neuen Inhalt ersetzen
        Zeile = sLine
      End If
      
      Print #N, Zeile
    Wend
    
    ' sollte LinePos grer sein, als die bisherige
    ' Anzahl gespeicherter Zeilen in der Orginaldatei
    ' wurde der neue Inhalt noch nicht gespeichert
    ' und die Datei muss ggf. noch mit zustzlichen
    ' Leerzeilen gefllt werden!
    If lRow < LinePos Then
      ' Ggf. mit Leerzeilen fllen
      For I = lRow + 1 To LinePos - 1
        Print #N, ""
      Next I
      
      ' Neuen Zeilen-Inhalt speichern
      Print #N, sLine
    End If
    
    ' Dateien schliessen
    Close #F: Close #N
    
    ' Alte Datei lschen
    Kill sFilename
    
    ' temporre Datei in "alte" Datei umbenennen
    FileCopy myTempFile, sFilename
    Kill myTempFile
  End If
End Sub

